require "xmlrpc"

-- How to write a server.  This file implements a number of test
-- methods, including the validator1 suite that
-- http://validator.xmlrpc.com/ uses to check for basic compliance
-- with the XML-RPC spec.

-- The last few lines implement a CGI responder.  If you have a Lua
-- web server, feel free to replace them.

localtest = {}
XMLRPC.registry.localtest = localtest

function localtest.towns() return "St. Peter", "Mankato" end
function localtest.lose() error("you lose") end
function localtest.echo(v) return v end

validator1 = {}
XMLRPC.registry.validator1 = validator1

function validator1.arrayOfStructsTest(l)
   local sum = 0
   for i=1,table.getn(l) do
      local elt = l[i]
      sum = sum + elt.curly
   end
   return sum
end

function count_instances(haystack, needle)
   local count = 0
   local init = 1
   while 1 do
      local first,last=string.find(haystack, needle, init, 1)
      if not first then return count end
      count = count + 1
      init = last + 1
   end
end

function validator1.countTheEntities(s)
   local t = {}
   t.ctLeftAngleBrackets = count_instances(s, "<")
   t.ctRightAngleBrackets = count_instances(s, ">")
   t.ctAmpersands = count_instances(s, "&")
   t.ctApostrophes = count_instances(s, "'")
   t.ctQuotes = count_instances(s, '"')
   return t
end

function validator1.easyStructTest(s)
   return s.moe + s.larry + s.curly
end

function validator1.echoStructTest(s)
   return s
end

function validator1.manyTypesTest(...)
   -- This is for you:   :-P
   return arg
end

function validator1.moderateSizeArrayCheck(l)
   return l[1]..l[table.getn(l)]
end

function validator1.nestedStructTest(s)
  local elt = s["2000"]["04"]["01"]
  return elt.moe + elt.larry + elt.curly
end

function validator1.simpleStructReturnTest(n)
  return {times10=n*10, times100=n*100, times1000=n*1000}
end


-- CGI-specific implementation begins here.

local input = io.input()
local output = io.output()

body=input:read("*a")

response = XMLRPC.dispatchString(body)
response = "<?xml version='1.0'?>\n"..response
response_len = string.len(response)

output:write("Status: 200 Ok\n")
output:write("Content-Length: "..tostring(response_len).."\n")
output:write("Content-Type: text/xml\n")
output:write("Connection: close\n")
output:write("\n")

output:write(response)
output:flush()

os.exit(0)
